#!/bin/bash
TARGET_HOST=$1
COPR_REPOS="ndmspc/ctp ndmspc/ctp-testing"
IPBUS_REPOS="base updates"
OUTPUT="/tmp/ctp-repos"
releasever=8
basearch=x86_64
WGET_COMMON="-q -r --no-clobber --no-parent --no-host-directories "

function GenRepo() {
REPO_TYPE=$(echo $1 | cut -d '/' -f1)
REPO_GROUP=$(echo $1 | cut -d '/' -f2)
REPO_NAME=$(echo $1 | cut -d '/' -f3)

cat <<EOF > $OUTPUT/$REPO_TYPE-$REPO_GROUP-$REPO_NAME.repo
[$REPO_GROUP-$REPO_NAME]
name=$REPO_GROUP/$REPO_NAME repo
baseurl=http://$TARGET_HOST/ctp-repos/$REPO_TYPE/$REPO_GROUP/$REPO_NAME
enabled=1
gpgcheck=0
EOF
}


if [ -z $TARGET_HOST ];then
  echo "$0 <target-host>"
  echo
  echo "example : '$0 alio2-cr1-ctpapp'"
  echo
  exit 1
fi

# rm -rf $OUTPUT
rm -rf $OUTPUT/*.repo
for r in $COPR_REPOS;do
    mkdir -p $OUTPUT/copr/$r
    cd $OUTPUT/copr/$r
    echo -n "Syncing 'copr/$r' to '$OUTPUT/copr/$r'"
    wget $WGET_COMMON --cut-dirs=4 https://copr-be.cloud.fedoraproject.org/results/$r/epel-$releasever-$basearch/ 
    GenRepo copr/$r
    echo "  [DONE]"
done

for r in $IPBUS_REPOS;do
    mkdir -p $OUTPUT/ipbus/uhal/$r
    cd $OUTPUT/ipbus/uhal/$r
    echo -n "Syncing 'ipbus/$r' to '$OUTPUT/ipbus/uhal/$r'"
    wget $WGET_COMMON --cut-dirs=8 https://ipbus.web.cern.ch/sw/release/2.8/repos/centos$releasever/$basearch/$r/RPMS/
    GenRepo ipbus/uhal/$r
    echo "  [DONE]"
done

echo -n "Doing 'rsync -a $OUTPUT $TARGET_HOST:/opt/'"
rsync -a $OUTPUT $TARGET_HOST:/usr/share/nginx/html/ || { echo "  [FAILED]"; exit 3; }
echo "  [OK]"
